<script lang="ts">
  import { keycloak } from '../../../stores.js';
  import { createKanbanComment, type KanbanComment, type KanbanTask } from '../../../models/Kanban.js';
  import type { TeamUser } from '@models/Team.js';
  import TaskComment from './TaskComment.svelte';
  import { Button, Input } from '@sveltestrap/sveltestrap';
  import { getNotificationsContext } from 'svelte-notifications';

  const { addNotification } = getNotificationsContext();

  export let task: KanbanTask;
  export let teammates: TeamUser[];

  let taskComments: KanbanComment[] = [];
  $: taskComments = task.comments || [];
  $: taskComments = taskComments.sort((c1, c2) => Date.parse(c2.created) - Date.parse(c1.created));

  let commentText: string;
  let showEditor: boolean = false;

  let myUserId: string | undefined;
  $: myUserId = $keycloak?.tokenParsed?.sub;
</script>

<div>
  <hr style="border-color: white" />
  <div class="d-flex flex-row">
    <div class="fs-4 text-muted flex-grow-1">Comments</div>
    <div>
      {#if !showEditor}<Button color="secondary" on:click={() => (showEditor = true)}>+ New Comment</Button>{/if}
    </div>
  </div>

  <div class="my-2">
    {#if showEditor}
      <div class="fs-5 text-muted">New Comment</div>
      <Input maxlength={600} type="textarea" style="min-height: 100px;" bind:value={commentText} />
      <div class="d-flex flex-row">
        <div class="text-muted flex-grow-1">
          <a href="https://commonmark.org/help/" rel="noopener noreferrer" target="_blank">Markdown</a> Formatting Supported
        </div>
        <Button class="m-2" color="danger" on:click={() => (showEditor = false)}>Cancel</Button>
        <Button
          class="my-2"
          color="primary"
          on:click={() => {
            if (!myUserId) return;
            if (commentText.length < 1) {
              addNotification({
                text: `Cannot post empty comment!`,
                position: 'bottom-right',
                removeAfter: 2500,
                type: 'error',
              });
              return;
            }
            let date = new Date().toISOString();
            createKanbanComment({
              author_id: myUserId,
              created: date,
              content: commentText,
              task_id: task.id,
              modified: date,
            });
            commentText = '';
            addNotification({
              text: `Comment Posted`,
              position: 'bottom-right',
              removeAfter: 2500,
              type: 'success',
            });
            showEditor = false;
          }}
        >
          Post Comment
        </Button>
      </div>
    {/if}
  </div>
  <div class="d-flex flex-column">
    {#each taskComments as comment (comment.id)}
      <div class="mb-2"><TaskComment {comment} {teammates} /></div>
    {/each}
  </div>
</div>
